;Ich billiger!
;Juni 2o18
;SpionAtom
;
SeedRnd MilliSecs()
Const picturePath$ = "BCC96"
Const xr = 640, yr = 480, fps = 60
Const cardSize = 64, pictureSize = 48, cardMargin = 5
Const maxOpenTime = 2000
Global openStartTime
Global fpsTimer = CreateTimer(fps)
Global mouse_x, mouse_y
Graphics xr, yr, 0, 2
AppTitle("Merk")

Type Image
	Field name$
	Field img
	Field number
End Type
Global TI.Image

Type Card
	Field x, y
	Field img
	Field opened
	Field onField
End Type
Global TC.Card

;load dem pixes
	SetBuffer BackBuffer()
	Local dir = ReadDir(picturePath$)
	ChangeDir(picturePath$)
	Local file$
	Global symbols = 0
	Repeat
		file$ = NextFile$(dir)
		If file$ = "" Then Exit
		If FileType(file$) = 1 Then
			TI = New Image
			TI\name = file$
			TI\img = LoadImage(file$)
			MaskImage TI\img, 255, 0, 255
			ResizeImage TI\img, pictureSize, pictureSize
			TI\number = symbols
			symbols = symbols + 1
		End If
	Forever

;Generate dem grafix	
	Global bg = CreateImage(xr, yr)
	SetBuffer ImageBuffer(bg)
	Local wall2 = GetImage("wall.png")
	For i = 0 To xr / ImageWidth(wall2)
	For j = 0 To yr / ImageHeight(wall2)
		DrawImage wall2, i * ImageWidth(wall2), j * ImageHeight(wall2)
	Next
	Next
	
	Global backCard = CreateImage(cardSize, cardSize)
	SetBuffer ImageBuffer(backCard)
	d = 8
	Color 33, 44, 55
	Oval 0, 0, d, d
	Oval 0, cardSize - d, d, d
	Oval cardSize - d, 0, d, d
	Oval cardSize - d, cardSize - d, d, d
	Rect d Shr 1, 0, cardSize - d, cardSize
	Rect 0, d Shr 1, cardSize, cardSize - d

;Place dem Cardz
	TI = First Image
	gridX = 10
	gridY = 10
	px = gridX
	py = gridY
	Dim CardArray.Card(2 * symbols)
	For cards = 0 To symbols - 1
		TC = New Card
		TC\x = px
		TC\y = py
		TC\img = TI\img
		TC\opened = False
		TC\onField = True
		px = px + cardSize + cardMargin
		If px > xr - cardSize - cardMargin Then
			px = gridX
			py = py + cardSize + cardMargin
		End If
		CardArray(2 * cards) = TC
		TC = New Card
		TC\x = px
		TC\y = py
		TC\img = TI\img
		TC\opened = False
		TC\onField = True
		px = px + cardSize + cardMargin
		If px > xr - cardSize - cardMargin Then
			px = gridX
			py = py + cardSize + cardMargin
		End If
		CardArray(2 * cards + 1) = TC
		TI = After TI
	Next
	
;Mix those tings
	For i = 0 To 2 * symbols - 1
		random = Rand(0, 2 * symbols - 1)
		tx = CardArray(i)\x
		ty = CardArray(i)\y
		CardArray(i)\x = CardArray(random)\x
		CardArray(i)\y = CardArray(random)\y
		CardArray(random)\x = tx
		CardArray(random)\y = ty
	Next

	Local phase = 0, mc.Card
	Local firstCard.Card, secondCard.Card
	SetBuffer BackBuffer()
	Repeat
		mouse_x = MouseX()
		mouse_y = MouseY()
		mc.Card = getMouseCard()
		mh = MouseHit(1)
		
		If phase = 0 And mc <> Null Then ;open first card
			If mh And mc\onField And mc\opened = False Then
				mc\opened = True
				phase = 1
				firstCard = mc
				FlushMouse()
			End If
		End If
	
		If phase = 1 And mc <> Null Then ;open second card
			If mh And mc\onField And mc\opened = False Then
				openStartTime = MilliSecs()
				mc\opened = True
				phase = 2
				secondCard = mc
				FlushMouse()
			End If
		End If
		
		If phase = 2 Then ;delay
			If MouseHit(2) Then phase = 3
			If openStartTime + maxOpenTime < MilliSecs() Then phase = 3
		End If
		
		If phase = 3 ;end round
			If firstCard\img = secondCard\img Then
				firstCard\onField = False
				secondCard\onField = False
				score = score + 1
				AppTitle("Merk - " + score + " von " + symbols + " Prchen aufgedeckt")
			End If
			firstCard\opened = False
			secondCard\opened = False			
			phase = 0
			If score = symbols Then phase = 4
		End If
	
		Cls
			DrawImage bg, 0, 0
			drawCards
			
			Color 255, 255, 255
			
			If mc <> Null Then Text 0, 0, mc\x + ", " + mc\y
			
			If phase = 4 Then 
				Cls
				win$ = "G E W O N N E N"
				Color 255, 255, 0
				Text (xr - StringWidth(win$)) / 2, (yr - StringHeight(win$)) / 2, win$
				Flip()
				WaitKey()
				End
			End If
		
		Flip(0)
		WaitTimer fpsTimer
	
	Until KeyDown(1)
	End
	
Function getMouseCard.Card()

	For i = 0 To 2 * symbols - 1
		c.Card = CardArray(i)
		If mouseInRect(c\x, c\y, cardSize, cardSize) Then
			Return c
		End If
	Next
	Return Null
	
End Function

Function drawCards()

	For i = 0 To 2 * symbols - 1
		drawCard CardArray(i)
	Next

End Function

Function drawCard(pCard.Card)

	If Not pCard\onField Then Return

	DrawImage backCard, pCard\x, pCard\y
	
	padding = (cardSize - pictureSize) / 2
	
	If pCard\opened Then
		DrawImage pCard\img, pCard\x + padding, pCard\y + padding
	End If

End Function
	
Function GetImage(imagename$)

	For TI = Each Image
		DebugLog TI\name
		If TI\name = imagename$ Then Return TI\img
	Next

End Function

Function mouseInRect(x, y, w, h) 

   If mouse_x < x Then Return False 
   If mouse_y < y Then Return False 
   If mouse_x > x + w Then Return False 
   If mouse_y > y + h Then Return False 
   Return True 

End Function 
;~IDEal Editor Parameters:
;~C#Blitz3D